import {
	Mode
} from '@jupyterlab/codemirror'

import CodeMirror from 'codemirror';

import 'codemirror/mode/python/python';
import './codemirror-multiplex';
import './codemirror-finesse2';

declare module 'codemirror' {
	function myMultiplexingMode(outerMode: CodeMirror.Mode<any>, ...others: object[]): CodeMirror.Mode<any>;
}	


CodeMirror.defineMode("finesse-python", (config) => {
	let pmode = CodeMirror.getMode(config, "python");
	return CodeMirror.myMultiplexingMode(
		pmode,
		{
			open: /(?=#kat2code)/,
			close: /(?=""")/, // Match string end without consuming it
			mode: CodeMirror.getMode(config, "text/x-finesse2"),
			delimStyle: "delim"
		}
	)
});

CodeMirror.defineMIME("text/x-finesse-python", "finesse-python");

Mode.getModeInfo().push({
	name: 'Finesse Python',
	mime: "text/x-finesse-python",
	mode: 'finesse-python',
	ext: [],
});
